#include "MinigameServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>
#include <sys/resource.h>

int main()
{
	struct rlimit core_limits;
	core_limits.rlim_cur = core_limits.rlim_max = RLIM_INFINITY;
	setrlimit(RLIMIT_CORE, &core_limits);

	Framework::initFramework();
	Zeit* z = getZeit();
	Text* pfad = new Text("../log/minigame/");
	pfad->append(z->getZeit("y-m-d h-i-s.log"));
	z->release();
	DateiPfadErstellen(pfad->getText());
	std::ofstream file;
	file.open(pfad->getText());
	std::streambuf* sbuf = std::cout.rdbuf();
	std::cout.rdbuf(file.rdbuf());
	pfad->release();

	std::cout << "MS: Startet...\n";
	std::cout << "MS: Lese init Datei ../data/misInit.ini ...\n";
	InitDatei* dat = new InitDatei("../data/misInit.ini");
	if (!dat->laden())
	{
		std::cout << "MS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit(1);
	}
	const char* wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv", "MGC_Pfad", "SSLCert", "SSLKey", "SSLPasswort" };
	for (const char* w : wichtig)
	{
		if (!dat->wertExistiert(w))
		{
			std::cout << "MS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
			dat->release();
			exit(1);
		}
	}

	MinigameServer* lServer = new MinigameServer(dat);

	std::cout << "MS: Der Admin Server luft. Startforgang beendet.\n";
	lServer->runn();

	lServer->ende();
	lServer->release();
	dat->release();
	std::cout << "MS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf(sbuf);
	Framework::releaseFramework();
	return 0;
}